#include "started_pch.h"
// For standard C++ printing (std::cout)
#include <iostream>
// For Naming Service capabilities
#include <orbsvcs/CosNamingC.h>
// To obtain handle to distributed Servant
#include "SimpleInterfaceC.h"
int main (int argc, char *argv[])
{
// Use ACE-specific TRY/CATCH mechanism
ACE_TRY_NEW_ENV
{
// Initialize and error check ORB
CORBA::ORB_var orb = CORBA::ORB_init (argc, argv);
if (CORBA::is_nil(orb.in()))
{
std::cout << "Could not initialize ORB" << std::endl;
exit(1);
}
CORBA::Object_var NameServiceObjectVar = orb->resolve_initial_references("NameService");
// Initialize and error check Naming Service objects
if (CORBA::is_nil(NameServiceObjectVar.in()))
{
std::cout << "Could not initialize Naming Service" << std::endl;
exit(1);
}
CosNaming::NamingContext_var NamingContextVar =
CosNaming::NamingContext::_narrow(NameServiceObjectVar.in());
if (CORBA::is_nil(NamingContextVar.in()))
{
std::cout << "Could not initialize Naming Context" << std::endl;
exit(1);
}
// Obtain and error check handle to the distributed Servant
CosNaming::Name UCastName(1);
UCastName.length(1);
UCastName[0].id = CORBA::string_dup("Serv1");
CORBA::Object_var UCastTemp = NamingContextVar->resolve(UCastName);
if (CORBA::is_nil(UCastTemp.in()))
{
std::cout << "Could not initialize UCastTemp" << std::endl;
exit(1);
}
SimpleInterface_var UNI_handle =
SimpleInterface::_narrow(UCastTemp);
if (CORBA::is_nil (UNI_handle.in ()))
{
std::cout << "Could not initialize unicast handle" << std::endl;
exit(1);
}
// Send unicast messages to the Servant
UNI_handle->send_forty_two(42);
short one = UNI_handle->getOne();
std::cout << "Value received from getOne: " << one << std::endl;
UNI_handle->shutdown();
// Cleanup
orb->destroy ();
}
ACE_CATCHANY
{
ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
"Exception caught:");
return 1;
}
ACE_ENDTRY;
return 0;
}